<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/maps/fleetengine/v1/vehicle_api.proto

namespace Maps\Fleetengine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * `ListVehicles` request message.
 *
 * Generated from protobuf message <code>maps.fleetengine.v1.ListVehiclesRequest</code>
 */
class ListVehiclesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * The standard Fleet Engine request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.RequestHeader header = 12;</code>
     */
    protected $header = null;
    /**
     * Required. Must be in the format `providers/{provider}`.
     * The provider must be the Project ID (for example, `sample-cloud-project`)
     * of the Google Cloud Project of which the service account making
     * this call is a member.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $parent = '';
    /**
     * The maximum number of vehicles to return.
     * Default value: 100.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    protected $page_size = 0;
    /**
     * The `next_page_token` value returned from a previous call to
     * `ListVehicles`. Functionality is undefined if the filter criteria of this
     * request don't match the criteria in the request that produced this
     * `page_token`.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    protected $page_token = '';
    /**
     * Specifies the required minimum capacity of the vehicle. All vehicles
     * returned will have a `maximum_capacity` greater than or equal to this
     * value. If set, must be greater or equal to 0.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value minimum_capacity = 6;</code>
     */
    protected $minimum_capacity = null;
    /**
     * Restrict the response to vehicles that support at least
     * one of the specified trip types.
     *
     * Generated from protobuf field <code>repeated .maps.fleetengine.v1.TripType trip_types = 7;</code>
     */
    private $trip_types;
    /**
     * Restrict the response to vehicles that have updated
     * their locations within the specified duration back from now.
     * If present, must be a valid positive duration.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration maximum_staleness = 8;</code>
     */
    protected $maximum_staleness = null;
    /**
     * Required. Restrict the response to vehicles with one of the specified type
     * categories.
     *
     * Generated from protobuf field <code>repeated .maps.fleetengine.v1.Vehicle.VehicleType.Category vehicle_type_categories = 9 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $vehicle_type_categories;
    /**
     * Callers can form complex logical operations using any combination of the
     * `required_attributes`, `required_one_of_attributes`, and
     * `required_one_of_attribute_sets` fields.
     * `required_attributes` is a list; `required_one_of_attributes` uses a
     * message which allows a list of lists. In combination, the two fields allow
     * the composition of this expression:
     * ```
     * (required_attributes[0] AND required_attributes[1] AND ...)
     * AND
     * (required_one_of_attributes[0][0] OR required_one_of_attributes[0][1] OR
     * ...)
     * AND
     * (required_one_of_attributes[1][0] OR required_one_of_attributes[1][1] OR
     * ...)
     * ```
     * Restrict the response to vehicles with the specified attributes. This field
     * is a conjunction/AND operation. Your app can specify up to 100 attributes;
     * however, the combined key:value string length cannot exceed 1024
     * characters.
     *
     * Generated from protobuf field <code>repeated string required_attributes = 10;</code>
     */
    private $required_attributes;
    /**
     * Restrict the response to vehicles with at least one
     * of the specified attributes in each `VehicleAttributeList`.
     * Within each list, a vehicle must match at least one of the attributes.
     * This field is an inclusive disjunction/OR operation in each
     * `VehicleAttributeList` and a conjunction/AND operation across the
     * collection of `VehicleAttributeList`. Format:
     * key1:value1|key2:value2|key3:value3...
     *
     * Generated from protobuf field <code>repeated string required_one_of_attributes = 13;</code>
     */
    private $required_one_of_attributes;
    /**
     * `required_one_of_attribute_sets` provides additional functionality.
     * Similar to `required_one_of_attributes`, `required_one_of_attribute_sets`
     * uses a message which allows a list of lists, allowing expressions such as
     * this one:
     * ```
     * (required_attributes[0] AND required_attributes[1] AND ...)
     * AND
     * (required_one_of_attributes[0][0] AND required_one_of_attributes[0][1] AND
     * ...)
     * OR
     * (required_one_of_attributes[1][0] AND required_one_of_attributes[1][1] AND
     * ...)
     * ```
     * Restrict the response to vehicles that match all the attributes in a
     * `VehicleAttributeList`. Within each list, a vehicle must match all of the
     * attributes. This field is a conjunction/AND operation in each
     * `VehicleAttributeList` and inclusive disjunction/OR operation across the
     * collection of `VehicleAttributeList`. Format:
     * key1:value1|key2:value2|key3:value3...
     *
     * Generated from protobuf field <code>repeated string required_one_of_attribute_sets = 15;</code>
     */
    private $required_one_of_attribute_sets;
    /**
     * Restrict the response to vehicles that have this vehicle state.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.VehicleState vehicle_state = 11;</code>
     */
    protected $vehicle_state = 0;
    /**
     * Only return the vehicles with current trip(s).
     *
     * Generated from protobuf field <code>bool on_trip_only = 14;</code>
     */
    protected $on_trip_only = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Maps\Fleetengine\V1\RequestHeader $header
     *           The standard Fleet Engine request header.
     *     @type string $parent
     *           Required. Must be in the format `providers/{provider}`.
     *           The provider must be the Project ID (for example, `sample-cloud-project`)
     *           of the Google Cloud Project of which the service account making
     *           this call is a member.
     *     @type int $page_size
     *           The maximum number of vehicles to return.
     *           Default value: 100.
     *     @type string $page_token
     *           The `next_page_token` value returned from a previous call to
     *           `ListVehicles`. Functionality is undefined if the filter criteria of this
     *           request don't match the criteria in the request that produced this
     *           `page_token`.
     *     @type \Google\Protobuf\Int32Value $minimum_capacity
     *           Specifies the required minimum capacity of the vehicle. All vehicles
     *           returned will have a `maximum_capacity` greater than or equal to this
     *           value. If set, must be greater or equal to 0.
     *     @type int[]|\Google\Protobuf\Internal\RepeatedField $trip_types
     *           Restrict the response to vehicles that support at least
     *           one of the specified trip types.
     *     @type \Google\Protobuf\Duration $maximum_staleness
     *           Restrict the response to vehicles that have updated
     *           their locations within the specified duration back from now.
     *           If present, must be a valid positive duration.
     *     @type int[]|\Google\Protobuf\Internal\RepeatedField $vehicle_type_categories
     *           Required. Restrict the response to vehicles with one of the specified type
     *           categories.
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $required_attributes
     *           Callers can form complex logical operations using any combination of the
     *           `required_attributes`, `required_one_of_attributes`, and
     *           `required_one_of_attribute_sets` fields.
     *           `required_attributes` is a list; `required_one_of_attributes` uses a
     *           message which allows a list of lists. In combination, the two fields allow
     *           the composition of this expression:
     *           ```
     *           (required_attributes[0] AND required_attributes[1] AND ...)
     *           AND
     *           (required_one_of_attributes[0][0] OR required_one_of_attributes[0][1] OR
     *           ...)
     *           AND
     *           (required_one_of_attributes[1][0] OR required_one_of_attributes[1][1] OR
     *           ...)
     *           ```
     *           Restrict the response to vehicles with the specified attributes. This field
     *           is a conjunction/AND operation. Your app can specify up to 100 attributes;
     *           however, the combined key:value string length cannot exceed 1024
     *           characters.
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $required_one_of_attributes
     *           Restrict the response to vehicles with at least one
     *           of the specified attributes in each `VehicleAttributeList`.
     *           Within each list, a vehicle must match at least one of the attributes.
     *           This field is an inclusive disjunction/OR operation in each
     *           `VehicleAttributeList` and a conjunction/AND operation across the
     *           collection of `VehicleAttributeList`. Format:
     *           key1:value1|key2:value2|key3:value3...
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $required_one_of_attribute_sets
     *           `required_one_of_attribute_sets` provides additional functionality.
     *           Similar to `required_one_of_attributes`, `required_one_of_attribute_sets`
     *           uses a message which allows a list of lists, allowing expressions such as
     *           this one:
     *           ```
     *           (required_attributes[0] AND required_attributes[1] AND ...)
     *           AND
     *           (required_one_of_attributes[0][0] AND required_one_of_attributes[0][1] AND
     *           ...)
     *           OR
     *           (required_one_of_attributes[1][0] AND required_one_of_attributes[1][1] AND
     *           ...)
     *           ```
     *           Restrict the response to vehicles that match all the attributes in a
     *           `VehicleAttributeList`. Within each list, a vehicle must match all of the
     *           attributes. This field is a conjunction/AND operation in each
     *           `VehicleAttributeList` and inclusive disjunction/OR operation across the
     *           collection of `VehicleAttributeList`. Format:
     *           key1:value1|key2:value2|key3:value3...
     *     @type int $vehicle_state
     *           Restrict the response to vehicles that have this vehicle state.
     *     @type bool $on_trip_only
     *           Only return the vehicles with current trip(s).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Maps\Fleetengine\V1\VehicleApi::initOnce();
        parent::__construct($data);
    }

    /**
     * The standard Fleet Engine request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.RequestHeader header = 12;</code>
     * @return \Maps\Fleetengine\V1\RequestHeader|null
     */
    public function getHeader()
    {
        return $this->header;
    }

    public function hasHeader()
    {
        return isset($this->header);
    }

    public function clearHeader()
    {
        unset($this->header);
    }

    /**
     * The standard Fleet Engine request header.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.RequestHeader header = 12;</code>
     * @param \Maps\Fleetengine\V1\RequestHeader $var
     * @return $this
     */
    public function setHeader($var)
    {
        GPBUtil::checkMessage($var, \Maps\Fleetengine\V1\RequestHeader::class);
        $this->header = $var;

        return $this;
    }

    /**
     * Required. Must be in the format `providers/{provider}`.
     * The provider must be the Project ID (for example, `sample-cloud-project`)
     * of the Google Cloud Project of which the service account making
     * this call is a member.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Must be in the format `providers/{provider}`.
     * The provider must be the Project ID (for example, `sample-cloud-project`)
     * of the Google Cloud Project of which the service account making
     * this call is a member.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of vehicles to return.
     * Default value: 100.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of vehicles to return.
     * Default value: 100.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * The `next_page_token` value returned from a previous call to
     * `ListVehicles`. Functionality is undefined if the filter criteria of this
     * request don't match the criteria in the request that produced this
     * `page_token`.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * The `next_page_token` value returned from a previous call to
     * `ListVehicles`. Functionality is undefined if the filter criteria of this
     * request don't match the criteria in the request that produced this
     * `page_token`.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * Specifies the required minimum capacity of the vehicle. All vehicles
     * returned will have a `maximum_capacity` greater than or equal to this
     * value. If set, must be greater or equal to 0.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value minimum_capacity = 6;</code>
     * @return \Google\Protobuf\Int32Value|null
     */
    public function getMinimumCapacity()
    {
        return $this->minimum_capacity;
    }

    public function hasMinimumCapacity()
    {
        return isset($this->minimum_capacity);
    }

    public function clearMinimumCapacity()
    {
        unset($this->minimum_capacity);
    }

    /**
     * Returns the unboxed value from <code>getMinimumCapacity()</code>

     * Specifies the required minimum capacity of the vehicle. All vehicles
     * returned will have a `maximum_capacity` greater than or equal to this
     * value. If set, must be greater or equal to 0.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value minimum_capacity = 6;</code>
     * @return int|null
     */
    public function getMinimumCapacityUnwrapped()
    {
        return $this->readWrapperValue("minimum_capacity");
    }

    /**
     * Specifies the required minimum capacity of the vehicle. All vehicles
     * returned will have a `maximum_capacity` greater than or equal to this
     * value. If set, must be greater or equal to 0.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value minimum_capacity = 6;</code>
     * @param \Google\Protobuf\Int32Value $var
     * @return $this
     */
    public function setMinimumCapacity($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int32Value::class);
        $this->minimum_capacity = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int32Value object.

     * Specifies the required minimum capacity of the vehicle. All vehicles
     * returned will have a `maximum_capacity` greater than or equal to this
     * value. If set, must be greater or equal to 0.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value minimum_capacity = 6;</code>
     * @param int|null $var
     * @return $this
     */
    public function setMinimumCapacityUnwrapped($var)
    {
        $this->writeWrapperValue("minimum_capacity", $var);
        return $this;}

    /**
     * Restrict the response to vehicles that support at least
     * one of the specified trip types.
     *
     * Generated from protobuf field <code>repeated .maps.fleetengine.v1.TripType trip_types = 7;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTripTypes()
    {
        return $this->trip_types;
    }

    /**
     * Restrict the response to vehicles that support at least
     * one of the specified trip types.
     *
     * Generated from protobuf field <code>repeated .maps.fleetengine.v1.TripType trip_types = 7;</code>
     * @param int[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTripTypes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Maps\Fleetengine\V1\TripType::class);
        $this->trip_types = $arr;

        return $this;
    }

    /**
     * Restrict the response to vehicles that have updated
     * their locations within the specified duration back from now.
     * If present, must be a valid positive duration.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration maximum_staleness = 8;</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getMaximumStaleness()
    {
        return $this->maximum_staleness;
    }

    public function hasMaximumStaleness()
    {
        return isset($this->maximum_staleness);
    }

    public function clearMaximumStaleness()
    {
        unset($this->maximum_staleness);
    }

    /**
     * Restrict the response to vehicles that have updated
     * their locations within the specified duration back from now.
     * If present, must be a valid positive duration.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration maximum_staleness = 8;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setMaximumStaleness($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->maximum_staleness = $var;

        return $this;
    }

    /**
     * Required. Restrict the response to vehicles with one of the specified type
     * categories.
     *
     * Generated from protobuf field <code>repeated .maps.fleetengine.v1.Vehicle.VehicleType.Category vehicle_type_categories = 9 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getVehicleTypeCategories()
    {
        return $this->vehicle_type_categories;
    }

    /**
     * Required. Restrict the response to vehicles with one of the specified type
     * categories.
     *
     * Generated from protobuf field <code>repeated .maps.fleetengine.v1.Vehicle.VehicleType.Category vehicle_type_categories = 9 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param int[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setVehicleTypeCategories($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Maps\Fleetengine\V1\Vehicle\VehicleType\Category::class);
        $this->vehicle_type_categories = $arr;

        return $this;
    }

    /**
     * Callers can form complex logical operations using any combination of the
     * `required_attributes`, `required_one_of_attributes`, and
     * `required_one_of_attribute_sets` fields.
     * `required_attributes` is a list; `required_one_of_attributes` uses a
     * message which allows a list of lists. In combination, the two fields allow
     * the composition of this expression:
     * ```
     * (required_attributes[0] AND required_attributes[1] AND ...)
     * AND
     * (required_one_of_attributes[0][0] OR required_one_of_attributes[0][1] OR
     * ...)
     * AND
     * (required_one_of_attributes[1][0] OR required_one_of_attributes[1][1] OR
     * ...)
     * ```
     * Restrict the response to vehicles with the specified attributes. This field
     * is a conjunction/AND operation. Your app can specify up to 100 attributes;
     * however, the combined key:value string length cannot exceed 1024
     * characters.
     *
     * Generated from protobuf field <code>repeated string required_attributes = 10;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRequiredAttributes()
    {
        return $this->required_attributes;
    }

    /**
     * Callers can form complex logical operations using any combination of the
     * `required_attributes`, `required_one_of_attributes`, and
     * `required_one_of_attribute_sets` fields.
     * `required_attributes` is a list; `required_one_of_attributes` uses a
     * message which allows a list of lists. In combination, the two fields allow
     * the composition of this expression:
     * ```
     * (required_attributes[0] AND required_attributes[1] AND ...)
     * AND
     * (required_one_of_attributes[0][0] OR required_one_of_attributes[0][1] OR
     * ...)
     * AND
     * (required_one_of_attributes[1][0] OR required_one_of_attributes[1][1] OR
     * ...)
     * ```
     * Restrict the response to vehicles with the specified attributes. This field
     * is a conjunction/AND operation. Your app can specify up to 100 attributes;
     * however, the combined key:value string length cannot exceed 1024
     * characters.
     *
     * Generated from protobuf field <code>repeated string required_attributes = 10;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRequiredAttributes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->required_attributes = $arr;

        return $this;
    }

    /**
     * Restrict the response to vehicles with at least one
     * of the specified attributes in each `VehicleAttributeList`.
     * Within each list, a vehicle must match at least one of the attributes.
     * This field is an inclusive disjunction/OR operation in each
     * `VehicleAttributeList` and a conjunction/AND operation across the
     * collection of `VehicleAttributeList`. Format:
     * key1:value1|key2:value2|key3:value3...
     *
     * Generated from protobuf field <code>repeated string required_one_of_attributes = 13;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRequiredOneOfAttributes()
    {
        return $this->required_one_of_attributes;
    }

    /**
     * Restrict the response to vehicles with at least one
     * of the specified attributes in each `VehicleAttributeList`.
     * Within each list, a vehicle must match at least one of the attributes.
     * This field is an inclusive disjunction/OR operation in each
     * `VehicleAttributeList` and a conjunction/AND operation across the
     * collection of `VehicleAttributeList`. Format:
     * key1:value1|key2:value2|key3:value3...
     *
     * Generated from protobuf field <code>repeated string required_one_of_attributes = 13;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRequiredOneOfAttributes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->required_one_of_attributes = $arr;

        return $this;
    }

    /**
     * `required_one_of_attribute_sets` provides additional functionality.
     * Similar to `required_one_of_attributes`, `required_one_of_attribute_sets`
     * uses a message which allows a list of lists, allowing expressions such as
     * this one:
     * ```
     * (required_attributes[0] AND required_attributes[1] AND ...)
     * AND
     * (required_one_of_attributes[0][0] AND required_one_of_attributes[0][1] AND
     * ...)
     * OR
     * (required_one_of_attributes[1][0] AND required_one_of_attributes[1][1] AND
     * ...)
     * ```
     * Restrict the response to vehicles that match all the attributes in a
     * `VehicleAttributeList`. Within each list, a vehicle must match all of the
     * attributes. This field is a conjunction/AND operation in each
     * `VehicleAttributeList` and inclusive disjunction/OR operation across the
     * collection of `VehicleAttributeList`. Format:
     * key1:value1|key2:value2|key3:value3...
     *
     * Generated from protobuf field <code>repeated string required_one_of_attribute_sets = 15;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRequiredOneOfAttributeSets()
    {
        return $this->required_one_of_attribute_sets;
    }

    /**
     * `required_one_of_attribute_sets` provides additional functionality.
     * Similar to `required_one_of_attributes`, `required_one_of_attribute_sets`
     * uses a message which allows a list of lists, allowing expressions such as
     * this one:
     * ```
     * (required_attributes[0] AND required_attributes[1] AND ...)
     * AND
     * (required_one_of_attributes[0][0] AND required_one_of_attributes[0][1] AND
     * ...)
     * OR
     * (required_one_of_attributes[1][0] AND required_one_of_attributes[1][1] AND
     * ...)
     * ```
     * Restrict the response to vehicles that match all the attributes in a
     * `VehicleAttributeList`. Within each list, a vehicle must match all of the
     * attributes. This field is a conjunction/AND operation in each
     * `VehicleAttributeList` and inclusive disjunction/OR operation across the
     * collection of `VehicleAttributeList`. Format:
     * key1:value1|key2:value2|key3:value3...
     *
     * Generated from protobuf field <code>repeated string required_one_of_attribute_sets = 15;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRequiredOneOfAttributeSets($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->required_one_of_attribute_sets = $arr;

        return $this;
    }

    /**
     * Restrict the response to vehicles that have this vehicle state.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.VehicleState vehicle_state = 11;</code>
     * @return int
     */
    public function getVehicleState()
    {
        return $this->vehicle_state;
    }

    /**
     * Restrict the response to vehicles that have this vehicle state.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.VehicleState vehicle_state = 11;</code>
     * @param int $var
     * @return $this
     */
    public function setVehicleState($var)
    {
        GPBUtil::checkEnum($var, \Maps\Fleetengine\V1\VehicleState::class);
        $this->vehicle_state = $var;

        return $this;
    }

    /**
     * Only return the vehicles with current trip(s).
     *
     * Generated from protobuf field <code>bool on_trip_only = 14;</code>
     * @return bool
     */
    public function getOnTripOnly()
    {
        return $this->on_trip_only;
    }

    /**
     * Only return the vehicles with current trip(s).
     *
     * Generated from protobuf field <code>bool on_trip_only = 14;</code>
     * @param bool $var
     * @return $this
     */
    public function setOnTripOnly($var)
    {
        GPBUtil::checkBool($var);
        $this->on_trip_only = $var;

        return $this;
    }

}

