<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/maps/fleetengine/v1/fleetengine.proto

namespace Maps\Fleetengine\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Describes a stopping point on a vehicle's route or an ending point on a
 * vehicle's trip.
 *
 * Generated from protobuf message <code>maps.fleetengine.v1.TripWaypoint</code>
 */
class TripWaypoint extends \Google\Protobuf\Internal\Message
{
    /**
     * The location of this waypoint.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.TerminalLocation location = 1;</code>
     */
    protected $location = null;
    /**
     * The trip associated with this waypoint.
     *
     * Generated from protobuf field <code>string trip_id = 2;</code>
     */
    protected $trip_id = '';
    /**
     * The role this waypoint plays in this trip, such as pickup or dropoff.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.WaypointType waypoint_type = 3;</code>
     */
    protected $waypoint_type = 0;
    /**
     * The path from the previous waypoint to the current waypoint.
     *
     * Generated from protobuf field <code>repeated .google.type.LatLng path_to_waypoint = 4;</code>
     */
    private $path_to_waypoint;
    /**
     * The encoded path from the previous waypoint to the current waypoint.
     * Decoding is not yet supported.
     *
     * Generated from protobuf field <code>string encoded_path_to_waypoint = 5;</code>
     */
    protected $encoded_path_to_waypoint = '';
    /**
     * The traffic conditions along the path to this waypoint.  Note that traffic
     * is only available for Google Map Platform Rides and Deliveries Solution
     * customers.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.ConsumableTrafficPolyline traffic_to_waypoint = 10;</code>
     */
    protected $traffic_to_waypoint = null;
    /**
     * The path distance from the previous waypoint to the current waypoint. If
     * the waypoint is the first waypoint in the list (e.g.,
     * `Vehicle.waypoints[0]` or `Trip.remaining_waypoints[0]`), then the value of
     * this field is undefined.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value distance_meters = 6;</code>
     */
    protected $distance_meters = null;
    /**
     * The estimated time of arrival at this waypoint.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp eta = 7;</code>
     */
    protected $eta = null;
    /**
     * The travel time from previous waypoint to this point. If the waypoint is
     * the first waypoint in the list (e.g., `Vehicle.waypoints[0]` or
     * `Trip.remaining_waypoints[0]`), then this value indicates the remaining
     * time to the waypoint.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 8;</code>
     */
    protected $duration = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Maps\Fleetengine\V1\TerminalLocation $location
     *           The location of this waypoint.
     *     @type string $trip_id
     *           The trip associated with this waypoint.
     *     @type int $waypoint_type
     *           The role this waypoint plays in this trip, such as pickup or dropoff.
     *     @type \Google\Type\LatLng[]|\Google\Protobuf\Internal\RepeatedField $path_to_waypoint
     *           The path from the previous waypoint to the current waypoint.
     *     @type string $encoded_path_to_waypoint
     *           The encoded path from the previous waypoint to the current waypoint.
     *           Decoding is not yet supported.
     *     @type \Maps\Fleetengine\V1\ConsumableTrafficPolyline $traffic_to_waypoint
     *           The traffic conditions along the path to this waypoint.  Note that traffic
     *           is only available for Google Map Platform Rides and Deliveries Solution
     *           customers.
     *     @type \Google\Protobuf\Int32Value $distance_meters
     *           The path distance from the previous waypoint to the current waypoint. If
     *           the waypoint is the first waypoint in the list (e.g.,
     *           `Vehicle.waypoints[0]` or `Trip.remaining_waypoints[0]`), then the value of
     *           this field is undefined.
     *     @type \Google\Protobuf\Timestamp $eta
     *           The estimated time of arrival at this waypoint.
     *     @type \Google\Protobuf\Duration $duration
     *           The travel time from previous waypoint to this point. If the waypoint is
     *           the first waypoint in the list (e.g., `Vehicle.waypoints[0]` or
     *           `Trip.remaining_waypoints[0]`), then this value indicates the remaining
     *           time to the waypoint.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Maps\Fleetengine\V1\Fleetengine::initOnce();
        parent::__construct($data);
    }

    /**
     * The location of this waypoint.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.TerminalLocation location = 1;</code>
     * @return \Maps\Fleetengine\V1\TerminalLocation|null
     */
    public function getLocation()
    {
        return $this->location;
    }

    public function hasLocation()
    {
        return isset($this->location);
    }

    public function clearLocation()
    {
        unset($this->location);
    }

    /**
     * The location of this waypoint.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.TerminalLocation location = 1;</code>
     * @param \Maps\Fleetengine\V1\TerminalLocation $var
     * @return $this
     */
    public function setLocation($var)
    {
        GPBUtil::checkMessage($var, \Maps\Fleetengine\V1\TerminalLocation::class);
        $this->location = $var;

        return $this;
    }

    /**
     * The trip associated with this waypoint.
     *
     * Generated from protobuf field <code>string trip_id = 2;</code>
     * @return string
     */
    public function getTripId()
    {
        return $this->trip_id;
    }

    /**
     * The trip associated with this waypoint.
     *
     * Generated from protobuf field <code>string trip_id = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setTripId($var)
    {
        GPBUtil::checkString($var, True);
        $this->trip_id = $var;

        return $this;
    }

    /**
     * The role this waypoint plays in this trip, such as pickup or dropoff.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.WaypointType waypoint_type = 3;</code>
     * @return int
     */
    public function getWaypointType()
    {
        return $this->waypoint_type;
    }

    /**
     * The role this waypoint plays in this trip, such as pickup or dropoff.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.WaypointType waypoint_type = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setWaypointType($var)
    {
        GPBUtil::checkEnum($var, \Maps\Fleetengine\V1\WaypointType::class);
        $this->waypoint_type = $var;

        return $this;
    }

    /**
     * The path from the previous waypoint to the current waypoint.
     *
     * Generated from protobuf field <code>repeated .google.type.LatLng path_to_waypoint = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getPathToWaypoint()
    {
        return $this->path_to_waypoint;
    }

    /**
     * The path from the previous waypoint to the current waypoint.
     *
     * Generated from protobuf field <code>repeated .google.type.LatLng path_to_waypoint = 4;</code>
     * @param \Google\Type\LatLng[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setPathToWaypoint($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Type\LatLng::class);
        $this->path_to_waypoint = $arr;

        return $this;
    }

    /**
     * The encoded path from the previous waypoint to the current waypoint.
     * Decoding is not yet supported.
     *
     * Generated from protobuf field <code>string encoded_path_to_waypoint = 5;</code>
     * @return string
     */
    public function getEncodedPathToWaypoint()
    {
        return $this->encoded_path_to_waypoint;
    }

    /**
     * The encoded path from the previous waypoint to the current waypoint.
     * Decoding is not yet supported.
     *
     * Generated from protobuf field <code>string encoded_path_to_waypoint = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setEncodedPathToWaypoint($var)
    {
        GPBUtil::checkString($var, True);
        $this->encoded_path_to_waypoint = $var;

        return $this;
    }

    /**
     * The traffic conditions along the path to this waypoint.  Note that traffic
     * is only available for Google Map Platform Rides and Deliveries Solution
     * customers.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.ConsumableTrafficPolyline traffic_to_waypoint = 10;</code>
     * @return \Maps\Fleetengine\V1\ConsumableTrafficPolyline|null
     */
    public function getTrafficToWaypoint()
    {
        return $this->traffic_to_waypoint;
    }

    public function hasTrafficToWaypoint()
    {
        return isset($this->traffic_to_waypoint);
    }

    public function clearTrafficToWaypoint()
    {
        unset($this->traffic_to_waypoint);
    }

    /**
     * The traffic conditions along the path to this waypoint.  Note that traffic
     * is only available for Google Map Platform Rides and Deliveries Solution
     * customers.
     *
     * Generated from protobuf field <code>.maps.fleetengine.v1.ConsumableTrafficPolyline traffic_to_waypoint = 10;</code>
     * @param \Maps\Fleetengine\V1\ConsumableTrafficPolyline $var
     * @return $this
     */
    public function setTrafficToWaypoint($var)
    {
        GPBUtil::checkMessage($var, \Maps\Fleetengine\V1\ConsumableTrafficPolyline::class);
        $this->traffic_to_waypoint = $var;

        return $this;
    }

    /**
     * The path distance from the previous waypoint to the current waypoint. If
     * the waypoint is the first waypoint in the list (e.g.,
     * `Vehicle.waypoints[0]` or `Trip.remaining_waypoints[0]`), then the value of
     * this field is undefined.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value distance_meters = 6;</code>
     * @return \Google\Protobuf\Int32Value|null
     */
    public function getDistanceMeters()
    {
        return $this->distance_meters;
    }

    public function hasDistanceMeters()
    {
        return isset($this->distance_meters);
    }

    public function clearDistanceMeters()
    {
        unset($this->distance_meters);
    }

    /**
     * Returns the unboxed value from <code>getDistanceMeters()</code>

     * The path distance from the previous waypoint to the current waypoint. If
     * the waypoint is the first waypoint in the list (e.g.,
     * `Vehicle.waypoints[0]` or `Trip.remaining_waypoints[0]`), then the value of
     * this field is undefined.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value distance_meters = 6;</code>
     * @return int|null
     */
    public function getDistanceMetersUnwrapped()
    {
        return $this->readWrapperValue("distance_meters");
    }

    /**
     * The path distance from the previous waypoint to the current waypoint. If
     * the waypoint is the first waypoint in the list (e.g.,
     * `Vehicle.waypoints[0]` or `Trip.remaining_waypoints[0]`), then the value of
     * this field is undefined.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value distance_meters = 6;</code>
     * @param \Google\Protobuf\Int32Value $var
     * @return $this
     */
    public function setDistanceMeters($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Int32Value::class);
        $this->distance_meters = $var;

        return $this;
    }

    /**
     * Sets the field by wrapping a primitive type in a Google\Protobuf\Int32Value object.

     * The path distance from the previous waypoint to the current waypoint. If
     * the waypoint is the first waypoint in the list (e.g.,
     * `Vehicle.waypoints[0]` or `Trip.remaining_waypoints[0]`), then the value of
     * this field is undefined.
     *
     * Generated from protobuf field <code>.google.protobuf.Int32Value distance_meters = 6;</code>
     * @param int|null $var
     * @return $this
     */
    public function setDistanceMetersUnwrapped($var)
    {
        $this->writeWrapperValue("distance_meters", $var);
        return $this;}

    /**
     * The estimated time of arrival at this waypoint.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp eta = 7;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEta()
    {
        return $this->eta;
    }

    public function hasEta()
    {
        return isset($this->eta);
    }

    public function clearEta()
    {
        unset($this->eta);
    }

    /**
     * The estimated time of arrival at this waypoint.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp eta = 7;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEta($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->eta = $var;

        return $this;
    }

    /**
     * The travel time from previous waypoint to this point. If the waypoint is
     * the first waypoint in the list (e.g., `Vehicle.waypoints[0]` or
     * `Trip.remaining_waypoints[0]`), then this value indicates the remaining
     * time to the waypoint.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 8;</code>
     * @return \Google\Protobuf\Duration|null
     */
    public function getDuration()
    {
        return $this->duration;
    }

    public function hasDuration()
    {
        return isset($this->duration);
    }

    public function clearDuration()
    {
        unset($this->duration);
    }

    /**
     * The travel time from previous waypoint to this point. If the waypoint is
     * the first waypoint in the list (e.g., `Vehicle.waypoints[0]` or
     * `Trip.remaining_waypoints[0]`), then this value indicates the remaining
     * time to the waypoint.
     *
     * Generated from protobuf field <code>.google.protobuf.Duration duration = 8;</code>
     * @param \Google\Protobuf\Duration $var
     * @return $this
     */
    public function setDuration($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Duration::class);
        $this->duration = $var;

        return $this;
    }

}

